/*
    multi-demension array (statically allocated)
*/

#include <stdio.h>
#include <stdlib.h>

#define K1 192
#define K2 96
#define K3 0

static int tarai(int, int, int);
static inline int tarai0(int, int, int);
static void initialize_cache_table(void);

int
main(int argc, char **argv)
{
    initialize_cache_table();
    printf("%d\n", tarai(K1, K2, K3));
    exit(0);
}

static int cache[K1+2][K1+2][K1+2];

static void
initialize_cache_table(void)
{
    int i, j, k;

    for (i = 0; i < K1+2; i++) {
        for (j = 0; j < K1+2; j++) {
            for (k = 0; k < K1+2; k++) {
                cache[i][j][k] = -2;
            }
        }
    }
}

static int
tarai(int x, int y, int z)
{
    int result;

    result = cache[x+1][y+1][z+1];
    if (result != -2)
        return result;
    result = tarai0(x, y, z);
    cache[x+1][y+1][z+1] = result;
    return result;
}

static inline int
tarai0(int x, int y, int z)
{
    if (x <= y) return y;
    return tarai(tarai(x-1, y, z),
                 tarai(y-1, z, x),
                 tarai(z-1, x, y));
}
